## hydrogen 1.0.0~rc1

=== CMakeLists.txt ===
#
# CMAKE SETUP
#

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
# http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
IF(COMMAND CMAKE_POLICY)
#	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)   # add_library
	CMAKE_POLICY(SET CMP0006 NEW)   # bundle destination property
ENDIF()
#
# PROJECT INFO
#
PROJECT(hydrogen)
SET(VERSION_MAJOR "1")
SET(VERSION_MINOR "0")
SET(VERSION_PATCH "0")
SET(VERSION_SUFFIX "rc1")

SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

IF(VERSION_SUFFIX)
	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
ELSE()
	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
ENDIF(VERSION_SUFFIX)

include(GNUInstallDirs)

SET(LIBSNDFILE_VERSION_PREV "1.0.17")

#
# CONFIG OPTIONS
#
SET(WANT_LIBTAR TRUE)
OPTION(WANT_DEBUG           "Build with debug information" ON)
IF(APPLE)
    OPTION(WANT_SHARED      "Build the core library shared." OFF)
    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" OFF)
ELSE()
    OPTION(WANT_SHARED      "Build the core library shared." ON)
    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" ON)
ENDIF()

OPTION(WANT_LIBARCHIVE      "Enable use of libarchive instead of libtar" ON)
OPTION(WANT_LADSPA          "Enable use of LADSPA plugins" ON)

IF(APPLE)
	OPTION(WANT_OSC  "Enable OSC support" OFF)
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
ELSE()
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
	OPTION(WANT_OSC  "Enable OSC support" ON)
ENDIF()

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" ON)
ELSE()
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
ENDIF()

IF(MINGW)
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" ON)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" ON)
ELSE()
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
ENDIF()
OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
OPTION(WANT_RUBBERBAND   "Include RubberBand (Audio Time Stretcher Library) support" OFF)
IF(APPLE)
    OPTION(WANT_COREAUDIO   "Include CoreAudio support" ON)
    OPTION(WANT_COREMIDI    "Include CoreMidi support" ON)
    OPTION(WANT_BUNDLE      "Build a MAC OSX bundle application" ON)
ENDIF()

OPTION(WANT_CPPUNIT         "Include CppUnit test suite" ON)

include(Sanitizers)

IF(WANT_DEBUG)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(H2CORE_HAVE_DEBUG TRUE)
ELSE()
    SET(CMAKE_BUILD_TYPE Release)
    SET(H2CORE_HAVE_DEBUG FALSE)
ENDIF()

OPTION(WANT_CLANG_TIDY "Use clang-tidy to check the sourcecode" OFF)
IF(WANT_CLANG_TIDY)
	find_program(CLANG_TIDY_CMD NAMES clang-tidy)
	IF(CLANG_TIDY_CMD)
		#use config from .clang-tidy
		SET(CMAKE_CXX_CLANG_TIDY clang-tidy)
	ENDIF()
ENDIF()


IF(WANT_BUNDLE)
    SET(H2CORE_HAVE_BUNDLE TRUE)
ELSE()
    SET(H2CORE_HAVE_BUNDLE FALSE)
ENDIF()

IF(WANT_SHARED)
    SET(H2CORE_LIBRARY_TYPE SHARED)
ELSE()
    SET(H2CORE_LIBRARY_TYPE STATIC)
ENDIF()

IF(WANT_DEBUG)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
ELSE()
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
ENDIF()

IF (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-implement-inlines")
ENDIF()

SET(CMAKE_CXX_FLAGS_RELEASE "")

SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")


IF(APPLE)
	#Compile for 32bit and 64bit intel macs
	SET (CMAKE_OSX_ARCHITECTURES "x86_64;")
ENDIF()
#
# MANDATORY PKGS AND DEFAULT OPTIONS
#
INCLUDE(StatusSupportOptions)
MANDATORY_PKG(Threads)
MANDATORY_PKG(LIBSNDFILE)

# http://doc.qt.io/qt-5/cmake-manual.html
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5Test REQUIRED)
FIND_PACKAGE(Qt5Xml REQUIRED)
FIND_PACKAGE(Qt5XmlPatterns REQUIRED)
FIND_PACKAGE(Qt5LinguistTools REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

IF(APPLE)
    INCLUDE_DIRECTORIES("/opt/local/include")
    LINK_DIRECTORIES("/opt/local/lib")

    #Without setting this, installation would go into /usr/local, which does not exist per default
    SET(CMAKE_INSTALL_PREFIX "/usr" )
ELSE(APPLE)
    SET(OSS_LIB_PATHS "${CMAKE_INSTALL_FULL_LIBDIR}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
ENDIF(APPLE)


#Installation paths
# TODO remove data from path
SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
# TODO remove data from path, could be .config/hydrogen
SET(H2_USR_PATH ".hydrogen")

SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
SET(MAX_COMPONENTS  32   CACHE STRING "Maximum number of components")
SET(MAX_NOTES       192  CACHE STRING "Maximum number of notes")
SET(MAX_FX          4    CACHE STRING "Maximum number of effects")
SET(MAX_BUFFER_SIZE 8192 CACHE STRING "Maximum size of buffer")

#
# HEADER LIBRARY FUNCTIONS
#
INCLUDE(CompileHelper)
INCLUDE(FindHelper)
INCLUDE(FindLadspa)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindZLIB)
INCLUDE(FindThreads)
COMPILE_HELPER(SSCANF ${CMAKE_SOURCE_DIR}/cmake/sscanf sscanf )
COMPILE_HELPER(RTCLOCK ${CMAKE_SOURCE_DIR}/cmake/rtclock rtclock )
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(libtar.h HAVE_LIBTAR_H)
CHECK_LIBRARY_EXISTS(tar tar_open "" HAVE_LIBTAR_OPEN)
CHECK_LIBRARY_EXISTS(tar tar_close "" HAVE_LIBTAR_CLOSE)
CHECK_LIBRARY_EXISTS(tar tar_extract_all "" HAVE_LIBTAR_EXTRACT_ALL)
IF(HAVE_LIBTAR_H AND HAVE_LIBTAR_OPEN AND HAVE_LIBTAR_CLOSE AND HAVE_LIBTAR_EXTRACT_ALL)
    SET(LIBTAR_OK TRUE)
ELSE()
    SET(LIBTAR_OK FALSE)
ENDIF()
FIND_HELPER(LIBTAR tar tar.h tar)
IF( NOT LIBTAR_FOUND OR NOT LIBTAR_OK OR NOT ZLIB_FOUND )
    SET(WANT_LIBTAR FALSE)
    MANDATORY_PKG(LIBARCHIVE)
ENDIF()
FIND_HELPER(LIBARCHIVE libarchive archive.h archive)
IF( WANT_LIBARCHIVE AND LIBARCHIVE_FOUND)
    SET(WANT_LIBTAR FALSE)
ENDIF()
FIND_HELPER(LIBSNDFILE sndfile sndfile.h sndfile)
FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
FIND_LADSPA(LADSPA ladspa.h noise)

FIND_HELPER(OSC liblo lo/lo.h lo)

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
ELSE()
	FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
ENDIF()

FIND_HELPER(JACK jack jack/jack.h jack)
CHECK_LIBRARY_EXISTS(jack jack_port_rename "" HAVE_JACK_PORT_RENAME)
FIND_HELPER(JACKSESSION jack jack/session.h jack)
IF(APPLE)
    FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
    FIND_LIBRARY(CORESERVICES_LIBRARY CoreServices)
    FIND_HELPER(COREAUDIO CoreAudio-2.0 coreaudio.h coreaudio)
    FIND_HELPER(COREMIDI CoreMidi coremidi.h coremidi)
ENDIF()
FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
FIND_HELPER(PULSEAUDIO libpulse pulse/pulseaudio.h pulse)
FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
FIND_HELPER(LRDF lrdf lrdf.h lrdf)

FIND_HELPER(RUBBERBAND rubberband rubberband/RubberBandStretcher.h rubberband)
FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)


# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
#set(CMAKE_AUTOMOC ON)


find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc_dir ALL COMMAND ${CMAKE_COMMAND}
		-E make_directory ${CMAKE_CURRENT_BINARY_DIR}/docs)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS doc_dir
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
		COMMENT "Generating API documentation with Doxygen"
		VERBATIM)
endif(DOXYGEN_FOUND)

#
# COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
#
SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
FOREACH( _pkg ${STATUS_LIST})
    COMPUTE_PKGS_FLAGS(${_pkg})
ENDFOREACH()

# LIBSNDFILE CHECKS
STRING( COMPARE GREATER "${LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
IF(LIBSNDFILE_VERSION_OK)
    SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
ELSE()
    SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats")
ENDIF()

# RUBBERBAND information
SET(LIBRUBBERBAND_MSG "The use of librubberband2 is marked as experimental.
*				 Because the current implementation produce wrong timing!
*				 So long this bug isn't solved, please disable this option.
*				 If rubberband-cli is installed, the hydrogen rubberband-function
*				 will work properly as expected.")

#
# CONFIG PROCESS SUMMARY
#
SET(reset "${_escape}[0m")
SET(red "${_escape}[1;31m")
SET(purple "${_escape}[1;35m")
SET(cyan "${_escape}[1;36m")

COLOR_MESSAGE("${cyan}Installation Summary${reset}
--------------------
* Install Directory            : ${CMAKE_INSTALL_PREFIX}
* User path                    : ${H2_USR_PATH}
* System path                  : ${H2_SYS_PATH}
* core library build as        : ${H2CORE_LIBRARY_TYPE}
* debug capabilities           : ${H2CORE_HAVE_DEBUG}
* macosx bundle                : ${H2CORE_HAVE_BUNDLE}
* fat build                    : ${WANT_FAT_BUILD}\n"
)

COLOR_MESSAGE("${cyan}Main librarires${reset}")
COLOR_MESSAGE("* ${purple}libQt${reset}                        : ${Qt5Widgets_VERSION}")
COLOR_MESSAGE("* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
*                                ${LIBSNDFILE_MSG}
* ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
* ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
* ${purple}ladspa${reset}                       : ${LADSPA_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Supported audio interfaces${reset}
--------------------------
* ${purple}ALSA${reset}                         : ${ALSA_STATUS}
* ${purple}OSS${reset}                          : ${OSS_STATUS}
* ${purple}JACK${reset}                         : ${JACK_STATUS}
* ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
* ${purple}OSC${reset}                          : ${OSC_STATUS}
* ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
* ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
* ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}
* ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Useful extensions${reset}
-----------------------------------------
* ${purple}LASH${reset}                         : ${LASH_STATUS}
* ${purple}LRDF${reset}                         : ${LRDF_STATUS}
* ${purple}RUBBERBAND${reset}                   : ${RUBBERBAND_STATUS}
*                                ${LIBRUBBERBAND_MSG}\n"
)

IF(WANT_DEBUG)
    COLOR_MESSAGE("${cyan}Miscellaneous capabilities${reset}
-----------------------------------------
* realtime clock               : ${HAVE_RTCLOCK}
* working sscanf               : ${HAVE_SSCANF}
* unit tests                   : ${CPPUNIT_STATUS}\n"
    )
ENDIF()

COLOR_MESSAGE("-----------------------------------------------------------------
${red}IMPORTANT:${reset}
  after installing missing packages, remove ${CMAKE_BINARY_DIR}/CMakeCache.txt before
  running cmake again!
-----------------------------------------------------------------\n"
)

=== data/i18n/CMakeLists.txt ===
# make clean does not delete *.ts and *.qm files
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM 1)

FILE(GLOB TS_FILES ${CMAKE_CURRENT_LIST_DIR}/*.ts)

QT5_ADD_TRANSLATION(QM_FILES ${TS_FILES})
ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})
INSTALL(FILES ${QM_FILES} DESTINATION "${H2_SYS_PATH}/data/i18n")

=== src/cli/CMakeLists.txt ===

FILE(GLOB_RECURSE h2cli_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIRS}
    ${OSC_INCLUDE_DIRS}
)

ADD_EXECUTABLE(h2cli WIN32 MACOSX_BUNDLE ${h2cli_SRCS} )

SET_PROPERTY(TARGET h2cli PROPERTY CXX_STANDARD 14)
TARGET_LINK_LIBRARIES(h2cli
	hydrogen-core-${VERSION}
	Qt5::Widgets
	${LASH_LIBRARIES}
	${OSC_LIBRARIES}
	)

ADD_DEPENDENCIES(h2cli hydrogen-core-${VERSION})

INSTALL(TARGETS h2cli RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/core/CMakeLists.txt ===

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/include/hydrogen/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" @ONLY)

FILE(GLOB_RECURSE hydrogen_INCLUDES include/*.h)
FILE(GLOB_RECURSE hydrogen_SOURCES src/*.cpp src/*.cc src/*.c)
LIST(APPEND hydrogen_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h)

ADD_LIBRARY( hydrogen-core-${VERSION} ${H2CORE_LIBRARY_TYPE} ${hydrogen_SOURCES})
INCLUDE_DIRECTORIES( include
    ${CMAKE_SOURCE_DIR}/include                 # regular headers
    ${CMAKE_CURRENT_BINARY_DIR}/include         # generated config.h
    ${QT_INCLUDES}
    ${LIBTAR_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${OSS_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${PORTAUDIO_INCLUDE_DIRS}
    ${PORTMIDI_INCLUDE_DIRS}
    ${COREAUDIO_INCLUDE_DIRS}
    ${COREMIDI_INCLUDE_DIRS}
    ${LASH_INCLUDE_DIRS}
    ${LRDF_INCLUDE_DIRS}
    ${OSC_INCLUDE_DIRS}
    ${RUBBERBAND_INCLUDE_DIRS}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
    ${LIBTAR_LIBRARIES}
    ${LIBARCHIVE_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${OSS_LIBRARIES}
    ${JACK_LIBRARIES}
    ${PORTAUDIO_LIBRARIES}
    ${PORTMIDI_LIBRARIES}
    ${AUDIOUNIT_LIBRARY}
    ${CORESERVICES_LIBRARY}
    ${COREAUDIO_LIBRARIES}
    ${COREMIDI_LIBRARIES}
    ${PULSEAUDIO_LIBRARIES}
    ${LASH_LIBRARIES}
    ${LRDF_LIBRARIES}
    ${RUBBERBAND_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${OSC_LIBRARIES}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
	Qt5::Core
	Qt5::Xml
	Qt5::XmlPatterns
)

#SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )
SET_PROPERTY(TARGET hydrogen-core-${VERSION} PROPERTY CXX_STANDARD 14)

INSTALL(TARGETS hydrogen-core-${VERSION}
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    # do not copy directory hierarchy
    #PUBLIC_HEADER DESTINATION include/hydrogen
)

IF(NOT APPLE AND NOT WIN32)
    INSTALL(DIRECTORY include DESTINATION "${CMAKE_INSTALL_PREFIX}" FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
    INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hydrogen" )
ENDIF()

=== src/player/CMakeLists.txt ===

FILE(GLOB_RECURSE h2player_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
)

ADD_EXECUTABLE(h2player WIN32 MACOSX_BUNDLE ${h2player_SRCS} )

SET_PROPERTY(TARGET h2player PROPERTY CXX_STANDARD 14)
TARGET_LINK_LIBRARIES(h2player
	hydrogen-core-${VERSION}
	Qt5::Widgets
	)

ADD_DEPENDENCIES(h2player hydrogen-core-${VERSION})

INSTALL(TARGETS h2player RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
hydrogen (1.0.0~rc1-0ubuntu0.20.04.1) focal; urgency=medium

  * New upstream version 1.0.0-rc1 (LP: #1883151)
    - several fixes to the Jack transport (missed/double beats at the begin of a pattern)
    - fixed audio artifaces when using the ALSA driver
    - fixed tempo problems/distorting when exporting a song
    - playback track now scales correctly

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Thu, 11 Jun 2020 08:32:39 -0700

=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Erich Eickmeyer <erich@ericheickmeyer.com>
Uploaders:
 Erich Eickmeyer <erich@ericheickmeyer.com>,
 Jonas Smedegaard <dr@jones.dk>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
  cdbs,
 debhelper,
 dh-buildinfo,
 cmake,
 qtbase5-dev,
 libz-dev,
 pkg-config,
 libarchive-dev,
 docbook-utils,
 poxml,
 xmlto,
 ladspa-sdk,
 libqt5xmlpatterns5-dev,
 libxml2-utils,
 libasound2-dev [linux-any],
 libjack-jackd2-dev,
 liblrdf-dev,
 liblo-dev,
 libsndfile1-dev,
 libtar-dev,
 portaudio19-dev,
 python3,
 qttools5-dev-tools,
 qttools5-dev,
 libportmidi-dev [linux-any],
 libpulse-dev
Standards-Version: 4.3.0
Homepage: http://www.hydrogen-music.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen

Package: hydrogen
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 hydrogen-data (= ${source:Version})
Recommends:
 hydrogen-drumkits,
 hydrogen-doc,
 rubberband-cli
Suggests:
 ladspa-plugin
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on QT 5.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 1.0.0~)
Replaces: hydrogen (<< 1.0.0~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 This package contains the architecture-independent data files.

Package: hydrogen-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: hydrogen (<< 1.0.0~)
Replaces: hydrogen (<< 1.0.0~)
Description: advanced drum machine/step sequencer (doc)
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 This package contains the architecture-independent documentation.

## hydrogen 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,17 +17,19 @@
 PROJECT(hydrogen)
 SET(VERSION_MAJOR "1")
 SET(VERSION_MINOR "0")
-SET(VERSION_PATCH "0")
-SET(VERSION_SUFFIX "rc1")
+SET(VERSION_PATCH "1")
+#SET(VERSION_SUFFIX "rc1")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
-IF(VERSION_SUFFIX)
-	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
-ELSE()
-	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
-	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
-ENDIF(VERSION_SUFFIX)
+SET(DISPLAY_VERSION "${VERSION}")
+
+#IF(VERSION_SUFFIX)
+#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+#ELSE()
+#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
+#ENDIF(VERSION_SUFFIX)
 
 include(GNUInstallDirs)
 
@@ -341,6 +343,3 @@
 ${red}IMPORTANT:${reset}
   after installing missing packages, remove ${CMAKE_BINARY_DIR}/CMakeCache.txt before
   running cmake again!
------------------------------------------------------------------\n"
-)
-

=== data/i18n/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,9 @@
 
 QT5_ADD_TRANSLATION(QM_FILES ${TS_FILES})
 ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})
-INSTALL(FILES ${QM_FILES} DESTINATION "${H2_SYS_PATH}/data/i18n")
+
+IF(MINGW)
+	INSTALL(FILES ${QM_FILES} DESTINATION "data/i18n")
+ELSE()
+	INSTALL(FILES ${QM_FILES} DESTINATION "${H2_SYS_PATH}/data/i18n")
+ENDIF()

=== src/gui/CMakeLists.txt ===

FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp)

# add undiscovered dependencies to generated config.h
INCLUDE(AddFileDependencies)
FOREACH( _file ${hydrogen_H} ${hydrogen_SRCS})
    FILE(READ "${_file}" _FILE_CONTENT)
    IF( "${_FILE_CONTENT}" MATCHES "H2CORE_HAVE_" )
        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/include/hydrogen/config.h)
    ENDIF()
ENDFOREACH()

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_BINARY_DIR}                 # ui_ headers
    ${CMAKE_CURRENT_SOURCE_DIR}/src             # gui headers
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
)

IF(APPLE)
	# set how it shows up in the Info.plist file
     	SET(MACOSX_BUNDLE_INFO_STRING "Hydrogen for Mac")
	SET(MACOSX_BUNDLE_ICON_FILE "icon.icns")
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "Hydrogen")
	SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${VERSION}")
	#this has to be short since it appears as the application name in the menu bar
	SET(MACOSX_BUNDLE_BUNDLE_NAME "Hydrogen")
	SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VERSION}")
	SET(MACOSX_BUNDLE_BUNDLE_VERSION "${VERSION}")
	SET(MACOSX_BUNDLE_COPYRIGHT "Hydrogen Developers, 2009")

  	# set where in the bundle to put the icns file
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	# include the icns file in the target
	SET(hydrogen_SRCS ${hydrogen_SRCS} ${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns)
	
	#copy the data folder
    FILE(COPY ${CMAKE_SOURCE_DIR}/data DESTINATION hydrogen.app/Contents/Resources PATTERN ".svn" EXCLUDE PATTERN i18n EXCLUDE)
  	
ENDIF()

ADD_EXECUTABLE(hydrogen WIN32 MACOSX_BUNDLE ${hydrogen_SRCS} ${hydrogen_MOC} ${hydrogen_UIS_H} ${CMAKE_SOURCE_DIR}/windows/icon.rc)
SET_PROPERTY(TARGET hydrogen PROPERTY CXX_STANDARD 14)
if(APPLE)
    add_custom_command(
        TARGET hydrogen
        POST_BUILD
        COMMAND plutil -replace NSPrincipalClass -string NSApplication hydrogen.app/Contents/Info.plist
    )
    add_custom_command(
        TARGET hydrogen
        POST_BUILD
        COMMAND plutil -replace NSHighResolutionCapable -bool true hydrogen.app/Contents/Info.plist
    )
endif()

TARGET_LINK_LIBRARIES(hydrogen
	hydrogen-core-${VERSION}
	Qt5::Widgets
)
ADD_DEPENDENCIES(hydrogen hydrogen-core-${VERSION})

INSTALL(TARGETS hydrogen RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/tests/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
add_definitions()
include_directories(
    ${CMAKE_SOURCE_DIR}/src/core/include            # core headers
    ${CMAKE_BINARY_DIR}/src/core/include            # generated config.h
    ${QT_INCLUDES}                                  # TODO be able to remove this
    ${CPPUNIT_INCLUDE_DIRS}
)

FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
link_directories()
add_executable(tests ${TESTS_SRCS})

SET_PROPERTY(TARGET tests PROPERTY CXX_STANDARD 14)

target_link_libraries(tests
	hydrogen-core-${VERSION}
	${CPPUNIT_LIBRARIES}
	Qt5::Core
	Qt5::Test
)

add_dependencies(tests hydrogen-core-${VERSION})

=== debian/changelog ===
hydrogen (1.0.1-3) unstable; urgency=medium

  * Add Breaks & Replaces to hydrogen for hydrogen-data (Closes: 983089)
    + Fixes the upgrade from buster to bullseye with the man page installation
  * Set upstream metadata fields: Archive, Bug-Database, Bug-Submit

 -- Dennis Braun <d_braun@kabelmail.de>  Fri, 19 Feb 2021 15:48:08 +0100

hydrogen (1.0.1-2) unstable; urgency=medium

  * control: Update my email address.
  * Do source-only upload to package can migrate to testing.

 -- Nicholas D Steeves <sten@debian.org>  Thu, 28 Jan 2021 23:04:01 -0500

hydrogen (1.0.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/control: Set Vcs-* to salsa.debian.org

  [ Filipe Sateler]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Olivier Humbert ]
  * Update d/changelog: deleting unnecessary empty lines
  * Update d/control:
    - add Pulseaudio to the description
    - debhelper: declare version
  * Update d/hydrogen.install (install a better image)

  [ Nicholas D Steeves ]
  * Reintroduce hydrogen to Debian. (Closes: #960539)
  * New upstream version 1.0.0~beta2.
  * Rebase all patches onto 1.0.0~beta2:
    - Drop 020170916~27d664c.patch (possibly resurrect).
    - Drop 1000_portaudio_v2.patch (no longer needed).
    - Drop 1001_rubberband_path.patch (merged upstream).
    - Drop 1002_fix_locale_coverage.patch (exists upstream @L42).
    - Drop 1005_name_shouldnt_repeat_genericname.patch (merged upstream).
    - Drop 1006_porttime.patch (merged upstream).
    - Drop 1008-ftbfs-gcc-4.7.diff (no longer needed).
    - Drop 1010-spelling.patch (no longer needed).
    - Drop 1015-man_path.patch (no longer needed).
    - Drop 1020-cxx_flags.patch (no longer needed).
  * Fix typos in description, enhance grammar, and refer to Qt as "Qt"
    rather than "QT". Thanks to Thomas Vincent for finding this while
    working on a translation. (Closes: #945042)
  * Update filenamemangle, uversionmangle, and version match to allow uscan
    to detect alpha, beta, and rc versions.  We're now tracking beta Qt5
    releases, because Qt4 is unmaintained and was removed from Debian.
  * Built against qtbase5-dev instead of libqt4-dev. (Closes: #954823)
  * Add the following new build-deps: libqt5xmlpatterns5-dev, qttools5-dev.
  * Add myself to Uploaders.
  * rules: export QTDIR=/usr/lib/qt5.
  * Add libcppunit-dev to build-deps; this will activate unit tests.
  * Add liblo-dev to build-deps; this enables Open Sound Control (OSC).
  * Add 1001-patch-stats.py-with-Python-2to3.patch.
  * Drop Jaromír Mikeš from Uploaders, because he has not been active in
    Debian for > 2 years, and because he communicated that he is no longer
    working on this package (see Bug #954823, Message #15).
  * Drop Jonas Smedegaard from Uploaders on his request (see Bug #954823,
    Message #37).
  * Migrate the package from cdbs to debhelper:
    - Switch to debhelper-compat 13.
    - Drop debian/control.in.
    - Drop cdbs build-dep.
    - Convert existing rules file into dh sequence compatible format, and
      drop the license boilerplate, because this is declared in Files:debian/*
      of copyright.
    - Install man page with debian/hydrogen.manpages.
    - Drop README.source, which existed to declare that this was a cdbs-using
      package.
    - Drop translation regeneration during dh_auto_build, because it replaces
      good translations with unfinished ones, eg: "Directory %1 does not
      exist" -> "Le répertoire %1 n'existe pas" is replace by "unfinished".
    - Drop copyright-check and copyright_hints, which were used in the cdbs
      rules, but which are no longer used.
  * Update hydrogen-data.install for new upstream locations of appdata.xml.
  * Update hydrogen-data.install and hydrogen-data.links for new upstream
    location of h2-icon.svg.
  * hydrogen.install: Drop icon installation, because it exists in
    hydrogen-data.
  * rules: export DEB_CMAKE_EXTRA_FLAGS
  * copyright:
    - Fix inaccurate date range for "The hydrogen development team".
    - Update Sebastian Moors' years.
    - Update Jérémy Zurcher's years.
    - Add missing section for cmake/Sanitizers.cmake.
    - Add missing section for Przemysław Sitek's files.
    - Add missing section for src/www/hydrogen.php.
    - Add myself to Files: debian/*
    - Drop License-Grant and License-Reference fields, because they are not
      part of DEP-5.
    - Add short license texts for GPL-2+, GPL-3+, and Apache-2.0, and include
      the conventional "On Debian systems, the complete text…can be
      found…common-licenses/license-name" text.
  * source/lintian-overrides: Bug #786450 has not yet been resolved.  Drop
    overrides for missing-license-paragraph-in-dep5 and
    missing-license-text-in-dep5, because they are no longer necessary with
    the changes to copyright noted above.
  * Add hydrogen-doc.links to make the manual, old tutorial, and new tutorial
    more discoverable by linking them to /usr/share/docs.
  * Register the tutorial with docbase.
  * Add lintian override for
    package-contains-documentation-outside-usr-share-doc.  See header of
    hydrogen-doc.lintian-overrides for more information.
  * Reimport upstream 1.0.1 using Sourceforge tarball, because the Github one
    omits the HTML manual (available in LANG codes: CA, EN, ES, FR, IT, and
    NL).  The New Tutorial is unfortunately only available in EN; however,
    the old tutorial continues to be provided for EN, FR, and IT.
  * Update watch file to use the Sourceforge source, and declare that we're
    using this source in copyright.
  * Drop build-dep on dh-buildinfo; this functionality is now provided by
    default with .buildinfo files.
  * control: Document why we can't use an https Homepage at this time.
  * 2001_avoid_live_non-free_drumkits.patch: Add missing original Date and
    Forwarded fields.
  * debian/tests/control: Add comment indicating why "allow-stderr" is


=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Nicholas D Steeves <sten@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 libqt5xmlpatterns5-dev,
 qttools5-dev,
 libcppunit-dev,
 libz-dev,
 pkg-config,
 libarchive-dev,
 docbook-utils,
 poxml,
 xmlto,
 libxml2-utils,
 libasound2-dev [linux-any],
 libjack-dev,
 liblrdf-dev,
 libsndfile1-dev,
 portaudio19-dev,
 libportmidi-dev [linux-any],
 libpulse-dev,
 liblo-dev
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: http://www.hydrogen-music.org/
# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen

Package: hydrogen
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 hydrogen-data (= ${source:Version})
Recommends:
 hydrogen-drumkits,
 hydrogen-doc,
 rubberband-cli
Suggests:
 ladspa-plugin
Breaks: hydrogen-data (<< 1.0.1-2)
Replaces: hydrogen-data (<< 1.0.1-2)
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on Qt 5.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 0.9.7-5~)
Replaces: hydrogen (<< 0.9.7-5~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent data files.

Package: hydrogen-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: hydrogen (<< 0.9.7-1~)
Replaces: hydrogen (<< 0.9.7-1~)
Description: advanced drum machine/step sequencer (doc)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CMAKE_EXTRA_FLAGS = -DWANT_SHARED=OFF \
 -DWANT_PORTAUDIO=ON \
 -DWANT_PORTMIDI=ON \
 -DWANT_RUBBERBAND=ON

export QTDIR=/usr/lib/qt5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build:
	mv ./data/img/h2-icon.bmp ./data/img/h2-icon.png
	dh_auto_build

override_dh_auto_clean:
	mv ./data/img/h2-icon.png ./data/img/h2-icon.bmp || true
	dh_auto_clean

=== debian/watch ===
version=4
http://sf.net/hydrogen/hydrogen-(\d\S+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## hydrogen 1.1.0~beta1

=== data/doc/Makefile ===
###
### must have the following commandline tools:
###
### itstool  (Debian package: itstool)
### msgfmt   (Debian package: gettext)
### msgmerge (Debian package: gettext)	
### xmlto    (Debian package: xmlto)
### xmllint  (Debian package: libxml2-utils)
###

MANUAL_MASTER = manual.docbook
TUTORIAL_MASTER = tutorial.docbook

XMLTO_OPTS = --stringparam section.autolabel=1 \
	--stringparam toc.max.depth=3 \
	--stringparam xref.with.number.and.title=0 \
	--stringparam section.label.includes.component.label=1 \
	--stringparam admon.graphics.extension=.svg \
	--stringparam admon.graphics=1 \
	--stringparam admon.graphics.path=img/admonitions/ \
	-m res/styling.xsd

ITSTOOL = itstool
MSGMERGE = msgmerge
MSGFMT = msgfmt
XMLTO = xmlto
XMLLINT = xmllint

all: *.html clean

clean:
	-rm -f *.mo *_validated *.dbk *.bak

%.html: %.dbk %.dbk_validated
	LL=$$(echo -n $< | sed 's/.*_\(..\)\.dbk/\1/') ; \
	$(XMLTO) html-nochunks $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		$<

%.dbk_validated: %.dbk
	$(XMLLINT) --noout --valid $^
	touch $@

## Special rule for master manual and tutorial
%_en.dbk: %.docbook
	cp -f $^ $@

manual_%.dbk: manual_%.mo manual_%.po $(MANUAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(MANUAL_MASTER)

manual_%.po: $(MANUAL_MASTER)
	$(ITSTOOL) -o manual.pot $<
	$(MSGMERGE) -U $@ manual.pot --backup=simple --no-wrap --verbose

manual_%.mo: manual_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

tutorial_%.dbk: tutorial_%.mo tutorial_%.po $(TUTORIAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(TUTORIAL_MASTER)

tutorial_%.po: $(TUTORIAL_MASTER)
	$(ITSTOOL) -o tutorial.pot $<
	$(MSGMERGE) -U $@ tutorial.pot --backup=simple --no-wrap --verbose

tutorial_%.mo: tutorial_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,23 +1,26 @@
 
-FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp)
+FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp src/*.h)
 
 # add undiscovered dependencies to generated config.h
 INCLUDE(AddFileDependencies)
 FOREACH( _file ${hydrogen_H} ${hydrogen_SRCS})
     FILE(READ "${_file}" _FILE_CONTENT)
     IF( "${_FILE_CONTENT}" MATCHES "H2CORE_HAVE_" )
-        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/include/hydrogen/config.h)
+        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/config.h)
     ENDIF()
 ENDFOREACH()
 
 INCLUDE_DIRECTORIES(
     ${CMAKE_CURRENT_BINARY_DIR}                 # ui_ headers
     ${CMAKE_CURRENT_SOURCE_DIR}/src             # gui headers
-    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
-    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
+    ${CMAKE_BINARY_DIR}/src                     # generated config.h
+    ${CMAKE_SOURCE_DIR}/src                     # top level headers
     ${QT_INCLUDES}
     ${LASH_INCLUDE_DIRS}
     ${LIBARCHIVE_INCLUDE_DIRS}
+    ${LIBSNDFILE_INCLUDE_DIRS}
+    ${JACK_INCLUDE_DIRS}
+
 )
 
 IF(APPLE)
@@ -43,7 +46,7 @@
 ENDIF()
 
 ADD_EXECUTABLE(hydrogen WIN32 MACOSX_BUNDLE ${hydrogen_SRCS} ${hydrogen_MOC} ${hydrogen_UIS_H} ${CMAKE_SOURCE_DIR}/windows/icon.rc)
-SET_PROPERTY(TARGET hydrogen PROPERTY CXX_STANDARD 14)
+SET_PROPERTY(TARGET hydrogen PROPERTY CXX_STANDARD 17)
 if(APPLE)
     add_custom_command(
         TARGET hydrogen
@@ -55,12 +58,37 @@
         POST_BUILD
         COMMAND plutil -replace NSHighResolutionCapable -bool true hydrogen.app/Contents/Info.plist
     )
+    add_custom_command(
+        TARGET hydrogen
+        POST_BUILD
+        COMMAND
+            plutil -extract CFBundleDocumentTypes json
+                   -o /dev/null
+                   hydrogen.app/Contents/Info.plist >/dev/null
+            || plutil -insert CFBundleDocumentTypes
+                      -json
+                         \"` cat ${CMAKE_SOURCE_DIR}/macos/CFBundleDocumentTypes.json `\"
+                       hydrogen.app/Contents/Info.plist )
+
+    ADD_DEPENDENCIES(hydrogen ${CMAKE_SOURCE_DIR}/macos/CFBundleDocumentTypes.json)
+
 endif()
 
 TARGET_LINK_LIBRARIES(hydrogen
 	hydrogen-core-${VERSION}
 	Qt5::Widgets
 )
+
+# Precompiled headers for Qt and std::vector. These dramatically reduce GUI build times
+if(${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.16)
+	target_precompile_headers(hydrogen
+		PUBLIC
+			<QtGui>
+			<QtWidgets>
+			<vector> )
+endif()
+
+
 ADD_DEPENDENCIES(hydrogen hydrogen-core-${VERSION})
 
-INSTALL(TARGETS hydrogen RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
+INSTALL(TARGETS hydrogen RUNTIME DESTINATION ${H2_BIN_PATH} BUNDLE DESTINATION ${H2_BIN_PATH})

=== debian/changelog ===
hydrogen (1.1.0~beta1-1~exp1) experimental; urgency=medium

  * New upstream release: version 1.1.0~beta1.
  * Rebase all patches onto this release.
  * Adjust hydrogen-doc.install for new location of documentation assets.
  * Remove build/CMakeCache.txt using dh_clean.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 07 May 2021 10:30:30 -0400

## hydrogen 1.1.0%7ebeta1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,22 +16,20 @@
 #
 PROJECT(hydrogen)
 SET(VERSION_MAJOR "1")
-SET(VERSION_MINOR "0")
-SET(VERSION_PATCH "1")
-#SET(VERSION_SUFFIX "rc1")
+SET(VERSION_MINOR "1")
+SET(VERSION_PATCH "0")
+SET(VERSION_SUFFIX "beta1")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
-SET(DISPLAY_VERSION "${VERSION}")
-
-#IF(VERSION_SUFFIX)
-#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
-#ELSE()
-#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
-#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
-#ENDIF(VERSION_SUFFIX)
-
-include(GNUInstallDirs)
+
+IF(VERSION_SUFFIX)
+	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+ELSE()
+	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
+ENDIF(VERSION_SUFFIX)
+
 
 SET(LIBSNDFILE_VERSION_PREV "1.0.17")
 
@@ -53,9 +51,7 @@
 
 IF(APPLE)
 	OPTION(WANT_OSC  "Enable OSC support" OFF)
-	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
-ELSE()
-	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
+ELSE()
 	OPTION(WANT_OSC  "Enable OSC support" ON)
 ENDIF()
 
@@ -84,6 +80,7 @@
 ENDIF()
 
 OPTION(WANT_CPPUNIT         "Include CppUnit test suite" ON)
+OPTION(FIXME_DISABLE_OPTIMIZATIONS "Fix broken builds by turning off optimizations" OFF)
 
 include(Sanitizers)
 
@@ -131,11 +128,13 @@
 
 SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")
 
-
-IF(APPLE)
-	#Compile for 32bit and 64bit intel macs
-	SET (CMAKE_OSX_ARCHITECTURES "x86_64;")
-ENDIF()
+IF(FIXME_DISABLE_OPTIMIZATIONS)
+    string(REGEX REPLACE "-O[0123s]" "-O0" CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS}")
+    string(REGEX REPLACE "-O[0123s]" "-O0" CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE}")
+    string(REGEX REPLACE "-O[0123s]" "-O0" CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG}")
+    string(REGEX REPLACE "-O[0123s]" "-O0" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
+ENDIF()
+
 #
 # MANDATORY PKGS AND DEFAULT OPTIONS
 #
@@ -164,9 +163,18 @@
 
 
 #Installation paths
-# TODO remove data from path
-SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
-# TODO remove data from path, could be .config/hydrogen
+INCLUDE(GNUInstallDirs)
+IF(WIN32)
+    SET(H2_BIN_PATH ".")
+    SET(H2_LIB_PATH ".")
+    SET(H2_DATA_PATH ".")
+    SET(H2_SYS_PATH "hydrogen")
+ELSE()
+    SET(H2_BIN_PATH ${CMAKE_INSTALL_BINDIR})
+    SET(H2_LIB_PATH ${CMAKE_INSTALL_LIBDIR})
+    SET(H2_DATA_PATH "${CMAKE_INSTALL_DATADIR}/hydrogen")
+    SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
+ENDIF()
 SET(H2_USR_PATH ".hydrogen")
 
 SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
@@ -221,7 +229,6 @@
 
 FIND_HELPER(JACK jack jack/jack.h jack)
 CHECK_LIBRARY_EXISTS(jack jack_port_rename "" HAVE_JACK_PORT_RENAME)
-FIND_HELPER(JACKSESSION jack jack/session.h jack)
 IF(APPLE)
     FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
     FIND_LIBRARY(CORESERVICES_LIBRARY CoreServices)
@@ -260,7 +267,7 @@
 #
 # COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
 #
-SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
+SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
 FOREACH( _pkg ${STATUS_LIST})
     COMPUTE_PKGS_FLAGS(${_pkg})
 ENDFOREACH()
@@ -270,7 +277,7 @@
 IF(LIBSNDFILE_VERSION_OK)
     SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
 ELSE()
-    SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats")
+	SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats. Found version: ${LIBSNDFILE_VERSION}")
 ENDIF()
 
 # RUBBERBAND information
@@ -293,6 +300,9 @@
 * Install Directory            : ${CMAKE_INSTALL_PREFIX}
 * User path                    : ${H2_USR_PATH}
 * System path                  : ${H2_SYS_PATH}
+* Bin path                     : ${H2_BIN_PATH}
+* Lib path                     : ${H2_LIB_PATH}
+* Data path                    : ${H2_DATA_PATH}
 * core library build as        : ${H2CORE_LIBRARY_TYPE}
 * debug capabilities           : ${H2CORE_HAVE_DEBUG}
 * macosx bundle                : ${H2CORE_HAVE_BUNDLE}
@@ -313,7 +323,6 @@
 * ${purple}ALSA${reset}                         : ${ALSA_STATUS}
 * ${purple}OSS${reset}                          : ${OSS_STATUS}
 * ${purple}JACK${reset}                         : ${JACK_STATUS}
-* ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
 * ${purple}OSC${reset}                          : ${OSC_STATUS}
 * ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
 * ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
@@ -331,15 +340,3 @@
 )
 
 IF(WANT_DEBUG)
-    COLOR_MESSAGE("${cyan}Miscellaneous capabilities${reset}
------------------------------------------
-* realtime clock               : ${HAVE_RTCLOCK}
-* working sscanf               : ${HAVE_SSCANF}
-* unit tests                   : ${CPPUNIT_STATUS}\n"
-    )
-ENDIF()
-
-COLOR_MESSAGE("-----------------------------------------------------------------
-${red}IMPORTANT:${reset}
-  after installing missing packages, remove ${CMAKE_BINARY_DIR}/CMakeCache.txt before
-  running cmake again!

## hydrogen 1.1.1

=== debian/changelog ===
hydrogen (1.1.1-1) unstable; urgency=medium

  * Upload to unstable.
  * Switch watch file to Github Releases, because upstream appears to have
    abandoned the sf.net project (eg: the 1.1.0 release tarball exists only
    on Github).
  * Also update Source in copyright.
  * Declare Standards-Version: 4.6.0.1 (no changes required).
  * Add lintian override for false positive
    inconsistent-appstream-metadata-license, because (gpl-2.0+ != gpl-2+) is
    false; these are equivalent expressions that refer to the same license.
  * Harmonise copyright file with upstream claims, and note the contributors
    who appear to have been deleted without a trace in the Comment field for
    "Files: *".

 -- Nicholas D Steeves <sten@debian.org>  Mon, 07 Feb 2022 23:43:16 -0700

## hydrogen 1.1.1%2B52.gb917e057

=== debian/control ===
--- 
+++ 
@@ -28,10 +28,11 @@
  libpulse-dev,
  liblo-dev
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Homepage: http://www.hydrogen-music.org/
 # Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
 # following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
+# This is remains unfixed as of 2021-12-12.
 Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen
